#!/bin/bash

log_file=/linuxcash/logs/current/upgrade_to_jammy.log

set -eu

log()
{
    echo `date` "$1"
}

# Отключаем диалоги
export DEBIAN_FRONTEND=noninteractive

export OLD_DISTRO=bionic
export OLD_NUMBER=18.04
export NEW_DISTRO=jammy
export NEW_NUMBER=22.04
export NEW_KVER=^6\.[0-9]+\.[0-9]+-[0-9]+-generic$

export DATA_PREFIX=/var/lib/artix-upgrade
export LIB_PREFIX=/usr/lib/artix-upgrade

_reboot() {
    if [ -d "$DATA_PREFIX" ]; then
        touch "$DATA_PREFIX"/stages/"$script".completed
        touch "$DATA_PREFIX"/continue
    fi
    systemctl --force reboot
    return 1
}

mkdir -p "$DATA_PREFIX"/stages
rm -f "$DATA_PREFIX"/continue
{
    for script in $(ls -1 "$LIB_PREFIX"/stages); do
        if [ ! -e "$DATA_PREFIX"/stages/"$script".completed ]; then
            source "$LIB_PREFIX"/stages/"$script"

            [ -d "$DATA_PREFIX"/stages ] && touch "$DATA_PREFIX"/stages/"$script".completed
        fi
    done
    log "Обновление выполнено успешно"
    printf "\nЧерез 30 секунд будет выполнена перезагрузка. Нажмите Ctrl+C для отмены\n"
    sleep 30
    _reboot
} |& tee -a "$log_file"
